function x=norme(vecteur)
	
	x=0;
        for i=1:length(vecteur);
                x=x+(vecteur(i)**2);
        end,
	x=sqrt(x);

endfunction

function [t]=Wolfe2(x,sim,d)
	tg=0;
	td=%inf;
	t=1;
	nite=0;
	[q0,dq0]=sim(x);
	dq0=dq0'*d;
	[qt,dqt]=sim(x+t*d);
	dqt=dqt'*d;

	m1=0.1;
	m2=0.9;
	
	while (qt > q0+m1*t*dq0) | ( (qt <= q0 + m1*t*dq0)&(dqt < m2*dq0) ),
		
        if nite>50 then
			disp('Boucle infinie dans la recherche de Wolfe');
			break;
		end;

		if  (qt > q0 + m1*t*dq0) then 
			td=t;
		else
			tg=t;
		end

		if (td==%inf) then
			t=10*tg;
		else
			t=(tg+td)/2;
		end

		[qt,dqt]=sim(x+t*d);
		dqt=dqt'*d;
		nite=nite+1;
	end
endfunction

function [x,nite]=opti_gradientWolfe(x0,sim,kmax,eps)
    nite=0;
    xk=x0;
    x=x0;
    pas=1;
    res=[];
    for j=1:kmax-1;
        [fk,gk]=sim(xk);
        [pas]=Wolfe2(xk,sim,-gk);
        xkk=xk-gk*pas;
        [fkk,gkk]=sim(xkk);
    
        if j<>1 & (norme(gkk)<eps) then
            break;
        end,
            
        xk=xkk;
        x=xkk;
        nite=nite+1;
        u=abs(fkk);
        res(j,1)=log(u);
    end  
endfunction



